local o=require"nixio.fs"
local e=require"nixio.util"
local e=require"luci.template.parser"
local e=luci.model.uci.cursor()
local a={}
for e in o.dir("/dev")do
if e:match("^sd[a-z]$")
or e:match("^mmcblk%d+$")
or e:match("^sata[a-z]$")
or e:match("^nvme%d+n%d+$")
then
table.insert(a,e)
end
end
local t={}
for e,a in pairs(a)do
local e={}
local i="/dev/"..a
e["name"]=a
e["dev"]=i
s=tonumber((o.readfile("/sys/class/block/%s/size"%a)))
e["size"]=s and math.floor(s/2048)
t[#t+1]=e
end
local o,a,e
o=Map("partexp","<font color='green'>"..translate("One click partition expansion mounting tool").."</font>",
translate("Automatically format and mount the target device partition. If there are multiple partitions, it is recommended to manually delete all partitions before using this tool.<br/>For specific usage, see:")..translate("<a href=\'https://github.com/sirpdboy/luci-app-partexp.git' target=\'_blank\'>GitHub @sirpdboy:luci-app-partexp</a>"))
a=o:section(TypedSection,"global")
a.anonymous=true
e=a:option(ListValue,"target_function",translate("Select function"),translate("Select the function to be performed"))
e:value("/overlay",translate("Expand application space overlay (/overlay)"))
e:value("/opt",translate("Used as Docker data disk (/opt)"))
e:value("/dev",translate("Normal mount and use by device name(/dev/x1)"))
e.default="/opt"
e=a:option(ListValue,"target_disk",translate("Destination hard disk"),translate("Select the hard disk device to operate"))
for a,t in ipairs(t)do
if t.name and t.size then
e:value(t.name,"%s (%s, %d MB)"%{t.name,t.dev,t.size})
elseif t.name then
e:value(t.name,"%s (%s)"%{t.name,t.dev})
end
end
e=a:option(Flag,"keep_config",translate("Keep configuration"),translate("Tick means to retain the settings"))
e:depends("target_function","/overlay")
e.default=0
e=a:option(Flag,'auto_format',translate('Format before use'),translate("Ticking indicates formatting"))
e:depends("target_function","/opt")
e:depends("target_function","/dev")
e.default=0
e=a:option(Button,"restart",translate("Perform operation"))
e.inputtitle=translate("Click to execute")
e.template='partexp'
return o
